#include <stdio.h>
#include <windows.h>

#ifdef WINELIB
extern __declspec(dllimport) WCHAR* _getws(WCHAR*);
#endif

extern __declspec(dllimport) void __getmainargs(int *argc, char** *argv,
                          char** *envp, int expand_wildcards, int *new_mode);

int main(int argc, char** argv)
{
    int wargc;
    WCHAR** wargv;
    int i;

    if ((argc>=2) && (strcmp(argv[1],"-i")==0))
    {
        WCHAR wbuf[1024];

        do {
            printf("Type command line to convert:\n");
            _getws(wbuf);

            if (*wbuf==0)
                break;

            wargc=0;
            wargv=CommandLineToArgvW(wbuf,&wargc);
            printf("CommandLineToArgvW -> wargc=%d\n",wargc);
            for (i=0;i<wargc;i++) {
                printf("%d [%S]\n",i,wargv[i]);
            }
        } while (1);
    }
    else
    {
        int new_mode;
        int argc2;
        char** argv2;
        char** envp2;

        printf("GetCommandLine=[%s]\n",GetCommandLine());

        printf("main -> argc=%d\n",argc);
        for (i=0;i<argc;i++) {
            printf("%d [%s]\n",i,argv[i]);
        }

        printf("main -> __argc=%d\n",__argc);
        for (i=0;i<__argc;i++) {
            printf("%d [%s]\n",i,__argv[i]);
        }

        new_mode=0;
        __getmainargs(&argc2,&argv2,&envp2,0,&new_mode);
        printf("__getmainargs -> argc=%d\n",argc2);
        for (i=0;i<argc2;i++) {
            printf("%d [%s]\n",i,argv2[i]);
        }

        printf("argv[0]=%p argv2[0]=%p\n",argv[0],argv2[0]);

        wargc=0;
        wargv=CommandLineToArgvW(GetCommandLineW(),&wargc);
        printf("CommandLineToArgvW -> wargc=%d\n",wargc);
        for (i=0;i<wargc;i++) {
            printf("%d [%S]\n",i,wargv[i]);
        }
    }

    return 0;
}
