#include <stdio.h>
#include <windows.h>

#ifndef WINELIB
#include <io.h>
#include <fcntl.h>

void OpenConsole()
{
    int fd;
    FILE* file;

    /* Allocate a new console */
    AllocConsole();

    /* Restore the standard file descriptors and handles */
    fd=_open_osfhandle((long)GetStdHandle(STD_INPUT_HANDLE),_O_TEXT);
    if (fd!=0) {
        dup2(fd,0);
        close(fd);
    }
    file=_fdopen(0,"r");
    *stdin=*file;

    fd=_open_osfhandle((long)GetStdHandle(STD_OUTPUT_HANDLE),_O_TEXT);
    if (fd!=1) {
        dup2(fd,1);
        close(fd);
    }
    file=_fdopen(1,"w");
    *stdout=*file;

    fd=_open_osfhandle((long)GetStdHandle(STD_ERROR_HANDLE),_O_TEXT);
    if (fd!=2) {
        dup2(fd,2);
        close(fd);
    }
    file=_fdopen(2,"w");
    *stderr=*file;
}
#endif

extern __declspec(dllimport) void __getmainargs(int *argc, char** *argv,
                          char** *envp, int expand_wildcards, int *new_mode);


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    int wargc;
    WCHAR** wargv;
    int argc;
    char** argv;
    char** envp;
    int new_mode;
    int i;

#ifndef WINELIB
    OpenConsole();
#endif

    printf("lpCmdLine      = [%s]\n",lpCmdLine);
    printf("GetCommandLine = [%s]\n",GetCommandLine());

    new_mode=0;
    __getmainargs(&argc,&argv,&envp,0,&new_mode);
    printf("__getmainargs -> argc=%d\n",argc);
    for (i=0;i<argc;i++) {
        printf("%d [%s]\n",i,argv[i]);
    }

    wargc=0;
    wargv=CommandLineToArgvW(GetCommandLineW(),&wargc);
    printf("CommandLineToArgvW -> wargc=%d\n",wargc);
    for (i=0;i<wargc;i++) {
        printf("%d [%S]\n",i,wargv[i]);
    }

#ifndef WINELIB
    printf("[Hit a key]\n");
    getchar();
#endif

    return 0;
}

